#include <windows.h>

#include "rc.h"


extern DWORD   dwPGPOnly;
extern DWORD   dwSpellOnly;
extern char    strComment[];


BOOL WINAPI ConfigDlg(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg) {
    case WM_INITDIALOG:
        CheckDlgButton(hDlg, IDC_PGPONLY, dwPGPOnly);
        CheckDlgButton(hDlg, IDC_SPELLONLY, dwSpellOnly);
        SetDlgItemText(hDlg, IDC_COMMENT, strComment);
        SendDlgItemMessage(hDlg, IDC_COMMENT, EM_LIMITTEXT, 75, 0);
        break;
    case WM_COMMAND:
        switch (LOWORD(wParam)) {
        case IDC_PGPONLY:
            if (IsDlgButtonChecked(hDlg, IDC_PGPONLY))
                CheckDlgButton(hDlg, IDC_SPELLONLY, 0);
            break;
        case IDC_SPELLONLY:
            if (IsDlgButtonChecked(hDlg, IDC_SPELLONLY))
                CheckDlgButton(hDlg, IDC_PGPONLY, 0);
            break;
        case IDOK:
            dwPGPOnly = IsDlgButtonChecked(hDlg, IDC_PGPONLY);
            dwSpellOnly = IsDlgButtonChecked(hDlg, IDC_SPELLONLY);
            if (!GetDlgItemText(hDlg, IDC_COMMENT, strComment, 76))
                *strComment = 0;
            EndDialog(hDlg, 1);
            break;
        case IDCANCEL:
            EndDialog(hDlg, 0);
            break;
        default:
            return FALSE;
        }
        break;
    default:
        return FALSE;
    }
    return TRUE;
}


void RegWriteCfg(DWORD dwPGPOnly, DWORD dwSpellOnly, char *strComment)
{
    HKEY    hkKey;  // address of buffer for opened handle  
    DWORD   dwDisp; // address of disposition value buffer 
    LONG    lRes;

    lRes = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\PGP\\Netscape half-Plugin",
                0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkKey, &dwDisp);
    if (lRes) {
        MessageBox(NULL, "Failed to Write to Registry", "halh-Plugin Config", MB_ICONEXCLAMATION | MB_OK);
        return;
    }

    lRes = RegSetValueEx(hkKey, "PGPOnly", 0, REG_DWORD, (BYTE *)&dwPGPOnly, sizeof(DWORD));
    lRes |= RegSetValueEx(hkKey, "SpellOnly", 0, REG_DWORD, (BYTE *)&dwSpellOnly, sizeof(DWORD));
    lRes |= RegSetValueEx(hkKey, "Comment", 0, REG_SZ, (BYTE *)strComment, lstrlen(strComment));
    if (lRes)
        MessageBox(NULL, "Failed to Write to Registry", "halh-Plugin Config", MB_ICONEXCLAMATION | MB_OK);

    RegCloseKey(hkKey);
}

void RegReadCfg(DWORD *dwPGPOnly, DWORD *dwSpellOnly, char *strComment)
{
    HKEY    hkKey;  // address of buffer for opened handle  
    DWORD   dwType, dwSize;
    LONG    lRes;

    lRes = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\PGP\\Netscape half-Plugin", 0, KEY_QUERY_VALUE, &hkKey);
    if (lRes) {
        *dwPGPOnly = 0;
        *dwSpellOnly = 0;
        return;
    }

    dwSize = sizeof(DWORD);
    lRes = RegQueryValueEx(hkKey,"PGPOnly", NULL, &dwType, (BYTE *)dwPGPOnly, &dwSize);
    if (lRes)
        *dwPGPOnly = 0;
    lRes = RegQueryValueEx(hkKey, "SpellOnly", NULL, &dwType, (BYTE *)dwSpellOnly, &dwSize);
    if (lRes)
        *dwSpellOnly = 0;
    dwSize = 76;
    lRes = RegQueryValueEx(hkKey, "Comment", NULL, &dwType, (BYTE *)strComment, &dwSize);
    if (lRes)
        *strComment = 0;

    RegCloseKey(hkKey);
}
