/*
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

*/
#include <windows.h>

#include <stdlib.h>
#include <string.h>

#include "spellchk.h"

#include "rc.h"

#define PGP_WIN32 1
#include "pgpUserInterface.h"
#include "pgpUtilities.h"
#include "pgpOptionList.h"
#include "pgpKeys.h"
#include "pgpPFLErrors.h"

#pragma comment(lib, "F:\\CODE\\pgp651i\\libs\\pgpcdk\\win32\\PGPcdk\\Release\\PGP_SDK.lib")
#pragma comment(lib, "F:\\CODE\\pgp651i\\libs\\pgpcdk\\win32\\PGPsdkUI\\Release\\PGPsdkUI.lib")

//F:\CODE\pgp651i\libs\pgpcdk\pub\include,F:\CODE\pgp651i\libs\pfl\common,F:\CODE\pgp651i\clients\net\win32\driver\minisdk

HINSTANCE       hInst, hInstSpell;


int bInit = 0, bPGP = 0;
char dllpath[_MAX_PATH] = "\0";

char *g_pBuf = NULL, *g_pNewBuf = NULL;
unsigned long g_SelStart = 0, g_SelEnd = 0, g_BufSize = 0;
unsigned int g_NewSize = 0;
char *g_Words[] = {"Sign", "Encrypt", "Encrypt and Sign", "Error"};
#define LAST_W 3
int g_op = LAST_W;
int g_done = 0;

PGPError err = kPGPError_NoErr;
PGPContextRef context = kInvalidPGPContextRef;
PGPKeySetRef recipientKeys = kInvalidPGPKeySetRef, allKeys = kInvalidPGPKeySetRef;
PGPKeyRef sigKey = kInvalidPGPKeyRef;
char *passphraseSig = NULL, *passphraseConv = NULL;
PGPUInt32 convEnc = 0;
char *strVersion = "Netscape PGP half-Plugin 0.14 by Disastry / PGPsdk v1.7.1";

extern "C" {
DWORD   dwPGPOnly = 0;
DWORD   dwSpellOnly = 0;
char    strComment[76] = "\0";

BOOL WINAPI ConfigDlg(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void RegWriteCfg(DWORD dwPGPOnly, DWORD dwSpellOnly, char *strComment);
void RegReadCfg(DWORD *dwPGPOnly, DWORD *dwSpellOnly, char *strComment);
}

ISpellChecker * pSpellChecker = NULL;

//ISpellChecker * SCAPI SC_Create();
//void SCAPI SC_Destroy(ISpellChecker *pSpellChecker);
ISpellChecker * (SCAPI *o_SC_Create)(void) = NULL;
void (SCAPI *o_SC_Destroy)(ISpellChecker *pSpellChecker) = NULL;


int PGP_Load(void)
{
    // Initialize the PGPsdk libs
    err = PGPsdkInit();
    if (IsPGPError(err))
        return 0;
    // Create the PGPContext
    err = PGPNewContext(kPGPsdkAPIVersion, &context);
    if (IsPGPError(err))
        return 0;
    err = PGPsdkUILibInit();
    if (IsPGPError(err))
        return 0;
    return 1;
}

void PGP_Unload(void)
{
    PGPsdkUILibCleanup();
    // Release the PGP context we've been using
    if (PGPContextRefIsValid(context))
        PGPFreeContext(context);
    // PGP library shutdown
    PGPsdkCleanup();
}


int LoadSpell(void)
{
    char *szBSl;
    GetModuleFileName(hInst, dllpath, sizeof(dllpath));
    szBSl = strrchr(dllpath, '\\');
    if (szBSl)
        *(++szBSl) = 0;
    else
        *dllpath = 0;
    strcat(dllpath, "sp3240_.dll");
    hInstSpell = LoadLibrary(dllpath);
    if (!hInstSpell)
        return 0;
    /*(FARPROC)o_SC_Create = */GetProcAddress(hInstSpell, "SC_CREATE");
    __asm mov o_SC_Create, eax
    /*(FARPROC)o_SC_Destroy = */GetProcAddress(hInstSpell, "SC_DESTROY");
    __asm mov o_SC_Destroy, eax
    if (!o_SC_Create || !o_SC_Destroy)
        return 0;
    return 1;
}

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    switch(fdwReason) {
    case DLL_PROCESS_ATTACH:
        hInst = hinstDLL;
        if (!bInit)
            bInit = LoadSpell();
        break;
    case DLL_THREAD_ATTACH:
        break;
    case DLL_PROCESS_DETACH:
        FreeLibrary(hInstSpell);
        break;
    case DLL_THREAD_DETACH:
        break;
    default:
        break;
    }
    return 1;
}


BOOL WINAPI SelectDlg(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg) {
    case WM_COMMAND:
        switch (LOWORD(wParam)) {
        case IDOK:
            EndDialog(hDlg, 1);
            break;
        case IDCANCEL:
            EndDialog(hDlg, 0);
            break;
        default:
            return FALSE;
        }
        break;
    default:
        return FALSE;
    }
    return TRUE;
}


__declspec(dllexport) ISpellChecker * SCAPI SC_CREATE()
{
    BOOL bShift, bCtrl;

    RegReadCfg(&dwPGPOnly, &dwSpellOnly, strComment);
    bShift = GetKeyState(VK_SHIFT)&0x8000;
    bCtrl = GetKeyState(VK_CONTROL)&0x8000;
    if (bShift && bCtrl) {
        if (DialogBox(hInst, "CONFIG", NULL, ConfigDlg))
            RegWriteCfg(dwPGPOnly, dwSpellOnly, strComment);
        bPGP = dwPGPOnly;
        bShift = bCtrl = 0;
    }
    bPGP = dwPGPOnly && !dwSpellOnly;
    if (bShift)
        bPGP = 0;
    else
    if (bCtrl)
        bPGP = 1;
    else
    if (!dwPGPOnly && !dwSpellOnly) {
        //bPGP = (MessageBox(NULL, "PGP Encrypt/Sign - Yes\nSpell Check - No", "Spell/PGP", MB_YESNO) == IDYES);
        bPGP = DialogBox(hInst, "SELECT", NULL, SelectDlg);
    }
    if (bPGP) {
        bPGP = PGP_Load();
        if (!bPGP) {
            MessageBox(NULL, "PGP Init Failed", "PGP", MB_OK);
            PGP_Unload();
            return NULL;
        }
        pSpellChecker = new ISpellChecker;
    } else {
        if (!o_SC_Create)
            return NULL;
        pSpellChecker = o_SC_Create();
    }
    return pSpellChecker;
}

__declspec(dllexport) void SCAPI SC_DESTROY(ISpellChecker *pSpellChecker)
{
    if (bPGP) {
        if (g_pBuf) {
            free(g_pBuf);
            g_pBuf = NULL;
        }
        PGP_Unload();
        delete pSpellChecker;
    } else {
        o_SC_Destroy(pSpellChecker);
    }
    pSpellChecker = NULL;
}


//----------------------------------


int SCAPI ISpellChecker::Initialize(int LangCode, int DialectCode,
                                 const char *DbPath, const char *PersonalDbFile)
{//+
    return 0; // success
}

int SCAPI ISpellChecker::SetCurrentLanguage(int LangCode, int DialectCode)
{//+
    return 0; // success
}

int SCAPI ISpellChecker::GetCurrentLanguage(int &LangCode, int &DialectCode)
{//+
    LangCode = 0x10;
    DialectCode = 0x80;
    return 0; // success
}

int SCAPI ISpellChecker::GetNumOfDictionaries(void)
{//+
    return 1; //2;
}

int SCAPI ISpellChecker::GetDictionaryLanguage(int Index, int &LangCode, int &DialectCode)
{//+
    LangCode = 0x10;
    DialectCode = Index ? 0x20 : 0x80;
    return 0; // success
}

int SCAPI ISpellChecker::SetBuf(const char *pBuf)
{
    if (g_pBuf)
        free(g_pBuf);
    g_pBuf = (char *)malloc(g_BufSize = lstrlen(pBuf));
    memcpy(g_pBuf, pBuf, g_BufSize);
    g_SelStart = 0;
    g_SelEnd = 0;
    //MessageBox(NULL, pBuf, "SetBuf", MB_OK);
    return 0; // success
}

int SCAPI ISpellChecker::SetBuf(const char *pBuf, unsigned long SelStart, unsigned long SelEnd)
{//+
    if (g_pBuf)
        free(g_pBuf);
    g_pBuf = (char *)malloc(g_BufSize = lstrlen(pBuf));
    memcpy(g_pBuf, pBuf, g_BufSize);
    g_SelStart = SelStart;
    g_SelEnd = SelEnd;
    //MessageBox(NULL, pBuf+SelStart, "SetBuf1", MB_OK);
    return 0; // success
}

int SCAPI ISpellChecker::ReplaceMisspelledWord(const char *NewWord, int AllInstances)
{
    PGPUInt32 numKeys;

    for (int ii=0; ii<LAST_W; ii++)
        if (!lstrcmpi(g_Words[ii], NewWord))
            break;
    g_op = ii;

    switch (g_op) {
    case 0:
	    while (1) {
    	    // Open default key rings.
            err = PGPOpenDefaultKeyRings(context, 0, &allKeys);
            if (IsPGPError(err))
                break;
            err = PGPSigningPassphraseDialog(context, allKeys, &sigKey,
                PGPOUIOutputPassphrase(context, &passphraseSig),
                PGPOUIVerifyPassphrase(context, TRUE),
                PGPOLastOption(context));
            if (IsPGPError(err))
                break;
            err = PGPEncode(context,
                PGPOSignWithKey(context, sigKey,
                    PGPOPassphrase(context, passphraseSig),
                    PGPOLastOption(context)),
                PGPOInputBuffer(context, g_pBuf+g_SelStart, g_SelEnd ? g_SelEnd - g_SelStart : g_BufSize),
                PGPOAllocatedOutputBuffer(context, (void **)&g_pNewBuf, 110000, &g_NewSize),
                PGPOClearSign(context, TRUE),
                PGPOVersionString(context, strVersion),
                *strComment ? PGPOCommentString(context, strComment)
                            : PGPONullOption(context),
                 PGPOLastOption(context));
            if (passphraseSig)
                PGPFreeData(passphraseSig);
            passphraseSig = NULL;
            break;
        }
        if (IsPGPError(err)) {
            MessageBox(NULL, "PGP Sign Failed", "PGP", MB_OK);
            g_op = LAST_W;
            g_NewSize = g_BufSize;
        } else
            g_done = 1;
        break;
    case 1:
	    while (1) {
    	    // Open default key rings.
            err = PGPOpenDefaultKeyRings(context, 0, &allKeys);
            if (IsPGPError(err))
                break;
            get_key1:
                err = PGPRecipientDialog(context, allKeys, TRUE, &recipientKeys,
                    PGPOUIDialogOptions(context,
                        PGPOUICheckbox(context, 802, "Conventional &Encrypt", NULL, 0 , &convEnc,
                            PGPOLastOption(context)),
                        PGPOLastOption(context)),
                    PGPOLastOption(context));
                if (IsPGPError(err))
                    break;
                err = PGPCountKeys(recipientKeys, &numKeys);
                if (IsPGPError(err))
                    break;
            if (!numKeys && !convEnc)
                goto get_key1;
            if (convEnc) {
                err = PGPConventionalEncryptionPassphraseDialog(context,
                    PGPOUIOutputPassphrase(context, &passphraseConv),
                    PGPOLastOption(context));
                if (IsPGPError(err))
                    break;
            }
            err = PGPEncode(context,
                numKeys ? PGPOEncryptToKeySet(context, recipientKeys)
                        : PGPONullOption(context),
                convEnc ? PGPOConventionalEncrypt(context,
                            PGPOPassphrase(context, passphraseConv),
                            PGPOLastOption(context))
                        : PGPONullOption(context),
                PGPOInputBuffer(context, g_pBuf+g_SelStart, g_SelEnd ? g_SelEnd - g_SelStart : g_BufSize),
                PGPOAllocatedOutputBuffer(context, (void **)&g_pNewBuf, 110000, &g_NewSize),
                PGPOVersionString(context, strVersion),
                *strComment ? PGPOCommentString(context, strComment)
                            : PGPONullOption(context),
                PGPOArmorOutput(context, TRUE),
                PGPODataIsASCII(context, TRUE),
                PGPOCompression(context, TRUE),
                PGPOLastOption(context));
            if (passphraseConv)
                PGPFreeData(passphraseConv);
            passphraseConv = NULL;
            break;
        }
        if (IsPGPError(err)) {
            MessageBox(NULL, "PGP Encrypt Failed", "PGP", MB_OK);
            g_op = LAST_W;
            g_NewSize = g_BufSize;
        } else
            g_done = 1;
        break;
    case 2:
	    while (1) {
    	    // Open default key rings.
            err = PGPOpenDefaultKeyRings(context, 0, &allKeys);
            if (IsPGPError(err))
                break;
            err = PGPSigningPassphraseDialog(context, allKeys, &sigKey,
                PGPOUIOutputPassphrase(context, &passphraseSig),
                PGPOUIVerifyPassphrase(context, TRUE),
                PGPOLastOption(context));
            if (IsPGPError(err))
                break;
            get_key2:
                err = PGPRecipientDialog(context, allKeys, TRUE, &recipientKeys,
                    PGPOUIDialogOptions(context,
                        PGPOUICheckbox(context, 802, "Conventional &Encrypt", NULL, 0 , &convEnc,
                            PGPOLastOption(context)),
                        PGPOLastOption(context)),
                    PGPOLastOption(context));
                if (IsPGPError(err))
                    break;
                err = PGPCountKeys(recipientKeys, &numKeys);
                if (IsPGPError(err))
                    break;
            if (!numKeys && !convEnc)
                goto get_key2;
            if (convEnc) {
                err = PGPConventionalEncryptionPassphraseDialog(context,
                    PGPOUIOutputPassphrase(context, &passphraseConv),
                    PGPOLastOption(context));
                if (IsPGPError(err))
                    break;
            }
            err = PGPEncode(context,
                numKeys ? PGPOEncryptToKeySet(context, recipientKeys)
                        : PGPONullOption(context),
                convEnc ? PGPOConventionalEncrypt(context,
                            PGPOPassphrase(context, passphraseConv),
                            PGPOLastOption(context))
                        : PGPONullOption(context),
                PGPOSignWithKey(context, sigKey,
                    PGPOPassphrase(context, passphraseSig),
                    PGPOLastOption(context)),
                PGPOInputBuffer(context, g_pBuf+g_SelStart, g_SelEnd ? g_SelEnd - g_SelStart : g_BufSize),
                PGPOAllocatedOutputBuffer(context, (void **)&g_pNewBuf, 110000, &g_NewSize),
                PGPOVersionString(context, strVersion),
                *strComment ? PGPOCommentString(context, strComment)
                            : PGPONullOption(context),
                PGPOArmorOutput(context, TRUE),
                PGPODataIsASCII(context, TRUE),
                PGPOCompression(context, TRUE),
                PGPOLastOption(context));
            if (passphraseConv)
                PGPFreeData(passphraseConv);
            passphraseConv = NULL;
            if (passphraseSig)
                PGPFreeData(passphraseSig);
            passphraseSig = NULL;
            break;
        }
        if (IsPGPError(err)) {
            MessageBox(NULL, "PGP Encrypt/Sign Failed", "PGP", MB_OK);
            g_op = LAST_W;
            g_NewSize = g_BufSize;
        } else
            g_done = 1;
        break;
        //g_NewSize = lstrlen(g_Words[g_op]);
        //g_pNewBuf = (char *)malloc(g_NewSize);
        //memcpy(g_pNewBuf, g_Words[g_op], g_NewSize);
        ////g_NewSize += g_SelStart + (g_BufSize - g_SelEnd);
        //g_done = 1;
        //break;
    default:
        g_NewSize = g_BufSize;
    }

    if (PGPKeySetRefIsValid(allKeys))
        PGPFreeKeySet(allKeys);
    if (PGPKeySetRefIsValid(recipientKeys))
        PGPFreeKeySet(recipientKeys);

    return 0;
}

unsigned long SCAPI ISpellChecker::GetBufSize()
{//+
    return ((g_SelEnd) ? g_NewSize + g_SelStart + (g_BufSize - g_SelEnd) : g_NewSize) + 1; // size of new text
}

int SCAPI ISpellChecker::GetBuf(char *pBuf, unsigned long BufSize)
{//+
    if (g_op>=LAST_W) {
        memcpy(pBuf, g_pBuf, g_BufSize);
        *(pBuf+g_BufSize) = 0;
        return 0;
    }
    *pBuf = 0;
    if (g_pBuf && g_SelStart) {
        memcpy(pBuf, g_pBuf, g_SelStart);
        *(pBuf+g_SelStart) = 0;
    }
    if (g_pNewBuf && g_NewSize) {
        memcpy(pBuf+g_SelStart, g_pNewBuf, g_NewSize);
        *(pBuf+g_SelStart+g_NewSize) = 0;
    }
    if (g_pBuf && g_SelEnd && g_BufSize - g_SelEnd) {
        memcpy(pBuf+g_SelStart+g_NewSize, g_pBuf+g_SelEnd, g_BufSize - g_SelEnd);
        *(pBuf+g_SelStart+g_NewSize+g_BufSize-g_SelEnd) = 0;
    }
    PGPFreeData(g_pNewBuf);
    //free(g_pNewBuf);
    g_pNewBuf = NULL;
    return 0;
}

int SCAPI ISpellChecker::GetNextMisspelledWord(unsigned long &Offset, unsigned long &Len)
{//+
    static cnt = 0;
    if (++cnt >= 20) // for Composer
        g_done = 1;
    if (g_done)
        return 1; // no more misspelled word
    Offset = g_SelStart;
    Len = g_SelEnd ? g_SelEnd - g_SelStart : g_BufSize;
    return 0; // found a misspelled word
}

void SCAPI ISpellChecker::SetNewBuf(const char *pBuf, int ReparseFromStart)
{
    if (g_pBuf)
        free(g_pBuf);
    g_pBuf = (char *)malloc(g_BufSize = lstrlen(pBuf));
    memcpy(g_pBuf, pBuf, g_BufSize);
    g_SelStart = 0;
    g_SelEnd = 0;
    //MessageBox(NULL, pBuf, "SetBuf", MB_OK);
}

int SCAPI ISpellChecker::CheckWord(const char *pWord)
{
    return 1; // valid word
}

int SCAPI ISpellChecker::GetNumAlternatives(const char *pWord)
{//+
    if (g_done)
        return 0;
    return LAST_W;
}

int SCAPI ISpellChecker::GetAlternative(int Index, char *pBuf, unsigned int BufSize)
{//+
    lstrcpyn(pBuf, g_Words[Index], min(BufSize, lstrlen(g_Words[Index])+1));
    return 0;
}

int SCAPI ISpellChecker::AddWordToPersonalDictionary(const char *pWord)
{//-
    return 0;
}

int SCAPI ISpellChecker::RemoveWordFromPersonalDictionary(const char *pWord)
{
    return 0;
}

int SCAPI ISpellChecker::IgnoreWord(const char *pWord)
{//+
    return 0;
}

int SCAPI ISpellChecker::GetFirstPersonalDictionaryWord(char *pBuf, int BufSize)
{//-
    return -1; //no more words
}

int SCAPI ISpellChecker::GetNextPersonalDictionaryWord(char *pBuf, int BufSize)
{//-
    return -1; //no more words
}

int SCAPI ISpellChecker::ResetPersonalDictionary()
{//-
    return 0;
}

ISpellChecker::~ISpellChecker()
{
}
/*

-----BEGIN PGP SIGNATURE-----
Version: PGP 6.5.3

iQA/AwUBOKkVDDBaTVEuJQxkEQIWTQCg/AoWkc8NG4frVva0t5dfDlDut40Anjex
80dJzTXv492sPRyiom3COAKJ
=X0jq
-----END PGP SIGNATURE-----
*/
